// Programm:  book_expl09.cpp
#include "abs_relh.hpp" // Wegen abs_addh1, abs_subh1, ...
#include "bnd_util.hpp" // Wegen Max_bnd_Xi()
#include <iostream>     // Wegen cout
using namespace cxsc;
using namespace std;
real T_x(const interval& Xi, const real& delx)
{
    interval One=interval(1),A,B,R;
    real dela,delb,del;
    abs_addh1(One,0,Xi,delx,A,dela); // absl. Fehler bzgl. 1+x
    abs_subh1(One,0,Xi,delx,B,delb); // absl. Fehler bzgl. 1-x
    abs_divh1(A,dela,B,delb,R,del);  // absl. Fehler bzgl. (1+x)/(1-x)
    return del;  // Rckgabe einer Schranke del des absoluten Fehlers.
}

int main()
{
    interval X;
    real bnd, diam = 1e-5, delx=0;
    cout << "Intervall X = ? "; cin >> X;
    Max_bnd_Xi(T_x,X,delx,diam,bnd);
    cout << RndUp << "Absolute Fehlerschranke = " << bnd << endl;
}
