// Programm:  book_expl16.cpp
#include "abs_relh.hpp" // Wegen rel_mulh4()
#include "bnd_arh.hpp"  // Wegen rel_1px_epsh()
#include "bnd_util.hpp" // Wegen Max_bnd_Xi()
#include <iostream>     // Wegen cout
using namespace cxsc;
using namespace std;

real T_x(const interval& Xi, const real& epsx)
{
    interval P,T;
    real eps,epsP;
    rel_mulh4(Xi,epsx,Xi,epsx,P,epsP); // epsP: rel. Fehler bzgl. x*x
    rel_1px_epsh(P,epsP,T,eps);      // eps:  rel. Fehler bzgl. 1+x*x
    return eps; // Rckgabe einer Schranke eps des relativen Fehlers.
}

int main()
{
    interval X;
    string("[1e-8,0.1]") >> X; // [1e-8,0.1] enthalten in X
    real bnd, diam = 1e-5, epsx=0;
    Max_bnd_Xi(T_x,X,epsx,diam,bnd);
    cout << RndUp << "Relative Fehlerschranke = " << bnd << endl;
}
