// Programm:  book_expl20.cpp
#include <iostream>    // Wegen cout
#include <rvector.hpp> // Wegen rvector a(0,N);
using namespace cxsc;  using namespace std;
int main()
{
    int N=3; // Polynomgrad 3
    rvector a(0,N); // Polynomkoeffizienten a[j], j=0,1,2,3;
    a[0]=1;  a[1]=0.5;  a[2]=-0.25;  a[3]=0.125;
    real x=0.125, y = a[Ub(a)]; // y: Startwert fr Hornerschema
    // Horner-Schema:
    for (int j=Ub(a)-1; j>=Lb(a); j--)
    {
	y = y*x+a[j];
    } // y: Maschinen-Nherung fr P_3(x);
    cout << RndNext << SetPrecision(16,16)
	 << "Polynom-Nherung = " << y << endl;
}
