// Programm:  book_expl28.cpp
#include "abs_relh.hpp" // Wegen rel_mulh2()
#include "bnd_util.hpp" // Wegen Max_bnd_Xi()
#include <imath.hpp>    // Wegen Z = ln(Xi);
#include <iostream>     // Wegen cout

using namespace cxsc;
using namespace std;

real T_x(const interval& Xi, const real& delx)
{
    interval LNP1_Xi,EXP_Xi,T;
    real eps,epsLNP1,epsEXP; 
    LNP1_Xi = lnp1(Xi);
    string("[2.5082e-16,2.5082e-16]") >> T;
    epsLNP1 = Sup(T);  // epsLNp1:  rel. Fehler von lnp1(x)
    EXP_Xi = exp(-Xi);
    string("[2.357963e-16,2.357963e-16]") >> T;
    epsEXP = Sup(T);
    rel_mulh4(EXP_Xi,epsEXP,LNP1_Xi,epsLNP1,T,eps);
    return eps;  // Rckgabe einer Schranke eps des relativen Fehlers.
} // T_x

int main()
{
    interval X1;
    string("[0.001,708.39]") >> X1;
    real bnd, diam = 1e-5, delx=0;
    Max_bnd_Xi(T_x,X1,delx,diam,bnd);
    cout << RndUp << endl
         << "   **   Relat. Fehlerschranke = " << bnd << endl << endl;
}
