// Programm:  book_expl13.cpp
#include "abs_relh.hpp" // Wegen abs_divh1()
#include "bnd_arh.hpp"  // Wegen abs_1px_delh(),abs_1mx_delh()
#include "bnd_util.hpp" // Wegen Max_bnd_Xi()
#include <iostream>     // Wegen cout
using namespace cxsc;
using namespace std;
real T_x(const interval& Xi, const real& delx)
{
    interval Z,N,T;
    real delz,deln,del;
    abs_1px_delh(Xi,delx,Z,delz); // absl. Fehler bzgl. 1+x
    abs_1mx_delh(Xi,delx,N,deln); // absl. Fehler bzgl. 1-x
    abs_divh1(Z,delz,N,deln,T,del);  // absl. Fehler bzgl. (1+x)/(1-x)
    return del;  // Rckgabe einer Schranke del des absoluten Fehlers.
}

int main()
{
    interval X;
    real bnd, diam = 1e-5, delx=0;
    cout << "Intervall X = ? "; cin >> X;
    Max_bnd_Xi(T_x,X,delx,diam,bnd);
    cout << RndUp << "Absolute Fehlerschranke = " << bnd << endl;
}
