// Programm staggered4.cpp
// Zur Demonstration des Einflusses des relativen Durchmessers eines
// Argumentintervalls x auf die Genauigkeit einer staggered Rechnung. 

#include <l_interval.hpp>
#include <iostream>

using namespace std;
using namespace cxsc;

int main()
{
    l_interval x,y;
    stagprec = 3;
    cout << "Gewaehlte Praezision:  stagprec = " << stagprec << endl;
    x = 3;  // x ist Punktintervall
    cout << "Praezision von x:  " << StagPrec(x) << endl;
    cout << SetDotPrecision(16,16) 
         << "Rel. Durchmesser von x: " << diam(x)/Inf(x) << endl;
    y = 1/x;
    cout << Scientific << SetDotPrecision(16*stagprec,16*stagprec+1)
         << "1/x = " << y << endl; 

    x = x + interval(0,1e-48);
    cout << "Praezision von x:  " << StagPrec(x) << endl;
    cout << SetDotPrecision(16,16) 
         << "Rel. Durchmesser von x: " << diam(x)/Inf(x) << endl;
    y = 1/x;
    cout << Scientific << SetDotPrecision(16*stagprec,16*stagprec+1)
         << "1/x = " << y << endl;

    x = 3; 
    x = x + interval(0,1e-32);
    cout << "Praezision von x:  " << StagPrec(x) << endl;
    cout << SetDotPrecision(16,16)
         << "Rel. Durchmesser von x: " << diam(x)/Inf(x) << endl;
    y = 1/x;
    cout << Scientific << SetDotPrecision(16*stagprec,16*stagprec+1)
         << "1/x = " << y << endl;
}
